Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports System.Drawing.Imaging
'Imports System.IO

Public Class recorteForm
    Inherits System.Windows.Forms.Form

#Region " Cdigo generado por el Diseador de Windows Forms "

    Public Sub New()
        MyBase.New()

        'El Diseador de Windows Forms requiere esta llamada.
        InitializeComponent()

        'Agregar cualquier inicializacin despus de la llamada a InitializeComponent()

    End Sub

    'Form reemplaza a Dispose para limpiar la lista de componentes.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Requerido por el Diseador de Windows Forms
    Private components As System.ComponentModel.IContainer

    'NOTA: el Diseador de Windows Forms requiere el siguiente procedimiento
    'Puede modificarse utilizando el Diseador de Windows Forms. 
    'No lo modifique con el editor de cdigo.
    Friend WithEvents PBox1 As System.Windows.Forms.PictureBox
    Friend WithEvents btCerrar As System.Windows.Forms.Button
    Friend WithEvents ToolTip1 As System.Windows.Forms.ToolTip
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(recorteForm))
        Me.PBox1 = New System.Windows.Forms.PictureBox()
        Me.btCerrar = New System.Windows.Forms.Button()
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        CType(Me.PBox1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'PBox1
        '
        Me.PBox1.Image = CType(resources.GetObject("PBox1.Image"), System.Drawing.Image)
        Me.PBox1.Location = New System.Drawing.Point(13, 8)
        Me.PBox1.Name = "PBox1"
        Me.PBox1.Size = New System.Drawing.Size(300, 300)
        Me.PBox1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.CenterImage
        Me.PBox1.TabIndex = 0
        Me.PBox1.TabStop = False
        Me.ToolTip1.SetToolTip(Me.PBox1, "PictureBox con rea circular de recorte")
        '
        'btCerrar
        '
        Me.btCerrar.BackColor = System.Drawing.Color.White
        Me.btCerrar.Cursor = System.Windows.Forms.Cursors.Hand
        Me.btCerrar.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.btCerrar.FlatStyle = System.Windows.Forms.FlatStyle.Flat
        Me.btCerrar.Font = New System.Drawing.Font("Tahoma", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.btCerrar.Location = New System.Drawing.Point(127, 316)
        Me.btCerrar.Name = "btCerrar"
        Me.btCerrar.Size = New System.Drawing.Size(72, 24)
        Me.btCerrar.TabIndex = 3
        Me.btCerrar.Text = "Cerrar"
        Me.ToolTip1.SetToolTip(Me.btCerrar, "Sale de la aplicacin")
        Me.btCerrar.UseVisualStyleBackColor = False
        '
        'recorteForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.CancelButton = Me.btCerrar
        Me.ClientSize = New System.Drawing.Size(326, 352)
        Me.ControlBox = False
        Me.Controls.Add(Me.btCerrar)
        Me.Controls.Add(Me.PBox1)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "recorteForm"
        Me.ShowInTaskbar = False
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "PictureBox redondo"
        CType(Me.PBox1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub

#End Region

    'ACTUAMOS EN EL EVENTO PAINT DEL PICTUREBOX
    ' El evento Paint se produce cada vez que se dibuja el formulario o cualquier otro control
    ' Aqu se rellena el PictureBox con la imagen elegida recortando sobre ella un crculo
    ' para crear la ventana del formulario que ser copiada de formas diferentes y guardada como archivos JPG
    Private Sub PBox1_Paint(sender As Object, e As PaintEventArgs) Handles PBox1.Paint
        ' Podemos mejorar el aspecto del borde redondeado aplicando antialias
        ' Graphics.SmoothingMode obtiene o establece la calidad de la representacin del objeto Graphics
        e.Graphics.SmoothingMode = SmoothingMode.AntiAlias
        ' Creamos un objeto de la clase GraphicsPath que representa una serie de lneas y curvas conectadas
        Dim curra As GraphicsPath = New GraphicsPath
        ' Manipulando las variables que se corresponden con los puntos x.y, ancho y alto de la figura podemos variar su aspecto
        Dim x, y, ancho, alto As Integer
        ' Posiciones x.y del objeto curra (las del control PictureBox)
        x = PBox1.Left
        y = PBox1.Top
        ' Anchura y altura del objeto curra, un poco menores que las del PictureBox para que se vea bien ajustado al control
        ancho = PBox1.Width - 24
        alto = PBox1.Height - 24
        ' Usamos el mtodo AddEllipse para agregar la forma de un crculo o elipse al trazado actual (el control PictureBox)
        curra.AddEllipse(New Rectangle(x, y, ancho, alto))
        ' En el PictureBox creamos una regin que se corresponde con la forma del objeto GraphicsPath (cculo)
        ' y se dibuja en el PictureBox asignando el objeto curra a la regin
        ' Region de System.Drawing describe el interior de una forma grfica formada por rectngulos y trazados
        Dim reg As Region
        reg = New Region(curra)
        PBox1.Region = reg
        ' Otra forma de realizarlo
        'pBox.Region = New Region(curra)
    End Sub

    'ACTUAMOS EN EL EVENTO PAINT DEL FORMULARIO
    ' El evento Paint se produce cada vez que se dibuja el formulario o cualquier otro control
    ' Aqu se rellena el PictureBox con la imagen elegida recortando sobre ella un crculo
    ' para crear la ventana del formulario que ser copiada de formas diferentes y guardada como archivos JPG
    'Private Sub Captura_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles MyBase.Paint
    '    ' Podemos mejorar el aspecto del borde redondeado aplicando antialias
    '    ' Graphics.SmoothingMode obtiene o establece la calidad de la representacin del objeto Graphics
    '    e.Graphics.SmoothingMode = SmoothingMode.AntiAlias
    '    ' Creamos un objeto de la clase GraphicsPath que representa una serie de lneas y curvas conectadas
    '    Dim curra As GraphicsPath = New GraphicsPath
    '    ' Manipulando las variables que se corresponden con los puntos x.y, ancho y alto de la figura podemos variar su aspecto
    '    Dim x, y, ancho, alto As Integer
    '    ' Posiciones x.y del objeto curra (las del control PictureBox)
    '    x = PBox1.Left
    '    y = PBox1.Top
    '    ' Anchura y altura del objeto curra, un poco menores que las del PictureBox para que se vea bien ajustado al control
    '    ancho = PBox1.Width - 24
    '    alto = PBox1.Height - 24
    '    ' Usamos el mtodo AddEllipse para agregar la forma de un crculo o elipse al trazado actual (el control PictureBox)
    '    curra.AddEllipse(New Rectangle(x, y, ancho, alto))
    '    ' En el PictureBox creamos una regin que se corresponde con la forma del objeto GraphicsPath (cculo)
    '    ' y se dibuja en el PictureBox asignando el objeto curra a la regin
    '    ' Region de System.Drawing describe el interior de una forma grfica formada por rectngulos y trazados
    '    Dim reg As Region
    '    reg = New Region(curra)
    '    PBox1.Region = reg
    '    ' Otra forma de realizarlo
    '    'pBox.Region = New Region(curra)
    'End Sub

    Private Sub btCerrar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btCerrar.Click
        Me.Close()
    End Sub

End Class
